<?php
// WizyTówka - funkcje.php
if ( !defined('WT') ) exit();

// BŁĄD

function blad ( $tresc, $zatrzymywac = true ) {
  include('admin/blad.php');
  if ($zatrzymywac)
    exit();
}

// PLIKI

function otworz_plik ( $nazwa_pliku ) {
  if ( !$otworz = file_get_contents( $nazwa_pliku ) )
    blad ('Nie udało się odczytać pliku '.$nazwa_pliku.'.');
  else
    return $otworz;
}

function zapisz_plik ( $nazwa_pliku , $tresc ) {
  if ( !fwrite ( fopen( $nazwa_pliku , 'w' ) , $tresc) )
    blad ('Nie udało się zapisać pliku '.$nazwa_pliku.'.');
  else
    return true;
}

function usun_plik ( $nazwa_pliku ) {
  if ( !unlink ( $nazwa_pliku ) )
    blad ('Nie udało się usunąć pliku '.$nazwa_pliku.'.',false);
  else
    return true;
}

function przemianuj_plik ( $nazwa_pliku_z, $nazwa_pliku_na ) {
  if ( !rename ( $nazwa_pliku_z, $nazwa_pliku_na ) )
    blad ('Nie udało się przemianować pliku '.$nazwa_pliku_z.' na '.$nazwa_pliku_na.'.');
  else
    return true;
}

function kopiuj_plik ( $nazwa_pliku_z, $nazwa_pliku_do ) {
  if ( !copy ( $nazwa_pliku_z, $nazwa_pliku_do ) )
    blad ('Nie udało się skopiować pliku pliku '.$nazwa_pliku_z.' do '.$nazwa_pliku_do.'.');
  else
    return true;
}

function wyslij_plik ( $tablica ) {
  $tablica['name'] = prosta_nazwa($tablica['name'],false);
  if ( $tablica['tmp_name'] != 0 )
    return false;
  elseif ( is_uploaded_file( $tablica['tmp_name'] ) and
           !file_exists ( PLIKI . '/' . $tablica['name'] ) and
           move_uploaded_file ( $tablica['tmp_name'], PLIKI . '/' . $tablica['name'] ) )
    return $tablica['name'];
  else {
    blad('Nie udało się wysłać pliku '.$tablica['name'].'.');
    return false;
  }
}

function rozmiar_pliku ( $nazwa_pliku, $suma = false ) {
  if ( $suma )
    static $zapamietana_suma = 0;
  if ( empty($nazwa_pliku) and $suma )
    $rozmiar = $zapamietana_suma;
  elseif ( !empty($nazwa_pliku) ) {
    $rozmiar = filesize( $nazwa_pliku );
    if ( !$rozmiar )
      blad('Nie udało się zmierzyć rozmiaru pliku '.$nazwa_pliku.'.',false);
    elseif ( $suma )
      $zapamietana_suma = $zapamietana_suma + $rozmiar;
  }
  if ( $rozmiar < 1024 )
    $jednostka = 'B';
  elseif ( $rozmiar < 1024 * 1024 ) {
    $rozmiar = $rozmiar / 1024;
    $jednostka = 'KiB';
  }
  else {
    $rozmiar = $rozmiar / 1024 / 1024;
    $jednostka = 'MiB';
  }
  $pozycja_kropki = strpos($rozmiar,'.')+3;
  if ( $pozycja_kropki === false )
    $pozycja_kropki = strlen($rozmiar)+1;
  $rozmiar = str_replace( '.', ',', substr( $rozmiar, 0, $pozycja_kropki ) );
  return $rozmiar.' '.$jednostka;
}

// odczyt i zapis konfiguracji

function odczyt_konf ( $sekcja , $ustawienie = null ) {
  static $konf = array();
  if ( empty($konf[$sekcja]) ) {
    $konf[$sekcja] = unserialize ( otworz_plik ( DANE . '/konf/' . $sekcja . '.wtk' ) );
  }
  if ( empty($ustawienie) )
    return $konf[$sekcja];
  else
    return $konf[$sekcja][$ustawienie];
}

function zapis_konf ( $sekcja , $tresc_do_zapisania , $zabezpieczenie_html = true ) {
  if ($zabezpieczenie_html)
    $tresc_do_zapisania = bezpieczny_html($tresc_do_zapisania);
  zapisz_plik ( DANE . '/konf/' . $sekcja . '.wtk' , serialize ($tresc_do_zapisania) );
}

function zapis_konf_poj ( $sekcja , $ustawienie , $tresc_do_zapisania , $zabezpieczenie_html = true ) {
  if ($zabezpieczenie_html)
    $tresc_do_zapisania = bezpieczny_html($tresc_do_zapisania);
  $tablica = odczyt_konf($sekcja);
  $tablica[$ustawienie] = $tresc_do_zapisania;
  zapisz_plik ( DANE . '/konf/' . $sekcja . '.wtk' , serialize ($tablica) );
}

// odczyt i zapis podstron oraz ich zawartości

function odczyt_podstrona ( $identyfikator , $odczytywanie_zawartosci = true ) {
  if ( file_exists ( DANE . '/podstrony/' . $identyfikator . '.wts' ) ) {
    $tablica = unserialize ( otworz_plik( DANE . '/podstrony/' . $identyfikator . '.wts' ) );
    if ( $odczytywanie_zawartosci ) {
      if ( file_exists ( DANE . '/podstrony/' . $identyfikator . '.wtz' ) )
        $tablica['zawartosc'] = unserialize ( otworz_plik( DANE . '/podstrony/' . $identyfikator . '.wtz' ) );
      else
        $tablica['zawartosc'] = array();
    }
    return $tablica;
  }
  else
    return false;
}

function zapis_podstrona ( $identyfikator , $strona , $zawartosc = null ) {
  zapisz_plik ( DANE . '/podstrony/' . $identyfikator . '.wts' , serialize ( $strona ) );
  if ( !empty($zawartosc) )
    zapisz_plik ( DANE . '/podstrony/' . $identyfikator . '.wtz' , serialize ( $zawartosc ) );
}

// wszystkie podstrony i wszystkie pliki

function wszystkie_podstrony () {
  $tablica = glob( DANE . '/podstrony/*.wts' );
  $tablica = array_map ( 'basename', $tablica );
  foreach ( $tablica as $numer => $element )
    $tablica[$numer] = substr ( $element, 0, strlen($element)-4 );
  return $tablica;
}

function wszystkie_pliki () {
  $tablica = glob( PLIKI . '/*' );
  $tablica = array_map ( 'basename', $tablica );
  foreach ( $tablica as $numer => $element ) {
    if ( is_dir( PLIKI . '/' . $element ) )
      unset( $tablica[$numer] );
  }
  return $tablica;
}

// odczyt motywów i typów stron

function odczyt_typ ( $nazwa ) {
  $lokalizacja = $nazwa[0];
  $nazwa = substr($nazwa,2);
  if ( $lokalizacja == 'd' and file_exists( DANE . '/typy/' . $nazwa . '.wtt' ) ) {
    $typ = parse_ini_file( DANE . '/typy/' . $nazwa . '.wtt' );
    $wlasne = true;
  }
  elseif ( $lokalizacja == 's' and file_exists( SYSTEM . '/typy/' . $nazwa . '.wtt' ) ) {
    $typ = parse_ini_file( SYSTEM . '/typy/' . $nazwa . '.wtt' );
    $wlasne = false;
  }
  else
    return false;
  $typ['pliki_dodatkowe'] = explode (',',$typ['pliki_dodatkowe']);
  $typ['nazwa'] = $nazwa;
  $typ['wlasne'] = $wlasne;
  return $typ;
}

function odczyt_motyw ( $nazwa ) {
  $lokalizacja = $nazwa[0];
  $nazwa = substr($nazwa,2);
  if ( $lokalizacja == 'd' and file_exists( DANE . '/motywy/' . $nazwa . '.wtm' ) ) {
    $motyw = parse_ini_file( DANE . '/motywy/' . $nazwa . '.wtm' );
    $wlasne = true;
  }
  elseif ( $lokalizacja == 's' and file_exists( SYSTEM . '/motywy/' . $nazwa . '.wtm' ) ) {
    $motyw = parse_ini_file( SYSTEM . '/motywy/' . $nazwa . '.wtm' );
    $wlasne = false;
  }
  else
    return false;
  if ( !empty($motyw['pliki_dodatkowe']) )
    $motyw['pliki_dodatkowe'] = explode (',',$motyw['pliki_dodatkowe']);
  $motyw['nazwa'] = $nazwa;
  $motyw['wlasne'] = $wlasne;
  return $motyw;
}

// ciągi znaków

function sprawdz_adres ( $ciag ) {
  if ( empty($ciag) )
    return false;
  return preg_match ( '/^http|https:\/\/[a-zA-Z0-9\.\-_\/:]+$/' , $ciag );
}

function sprawdz_email ( $ciag ) {
  if ( empty($ciag) )
    return false;
  return preg_match ( '/^[a-zA-Z0-9\.\-_]+@[a-zA-Z0-9\.\-_]+\.[a-zA-Z0-9\.\-_]{2,4}$/' , $ciag );
}

function sprawdz_nazwe ( $ciag ) {
  if ( empty($ciag) )
    return false;
  return preg_match ( '/^[a-zA-Z0-9ąćęłśóżźńĄĆĘŁŚÓŻŹŃ\,\/\\!?@\$%&\*\(\)\[\]\<\>\{\}_=\.\+:;\-\" ]+$/' , $ciag );
}

function prosta_nazwa ( $ciag, $male_litery = true ) {
    $pl_z  = array ( 'ą', 'ć', 'ę', 'ł', 'ń', 'ś', 'ó', 'ż', 'ź', 'Ą', 'Ć', 'Ę', 'Ł', 'Ń', 'Ś', 'Ó', 'Ż', 'Ź' );
    $pl_na = array ( 'a', 'c', 'e', 'l', 'n', 's', 'o', 'z', 'z', 'A', 'C', 'E', 'L', 'N', 'S', 'O', 'Z', 'Z' );
  if ( $male_litery )
    $ciag = strtolower( $ciag );
  $ciag = str_replace( $pl_z, $pl_na, $ciag );
  $znaki = array( ',', '/', "'", '"', "\\", '!', '?', '@', '$', '%', '&', '*', '(', ')', '[', ']', '<', '>', '{', '}', '=', '+', ':', ';' );
  $ciag = str_replace( $znaki, null, $ciag );
  $ciag = str_replace( ' ', '-', $ciag );
  if ( empty($ciag) )
    return '-';
  return $ciag;
}

// inne funkcje

function tekst ( $tekst, $markdown = true ) {
  if ( $markdown and odczyt_konf('ustawienia','markdown') ) {
    include_once ('markdown.php');
    $tekst = Markdown($tekst);
  }
  if ( odczyt_konf('ustawienia','typografia_pozostale') ) {
    $znaki_z  = array ( ' - ',       "'",       '... ',      ' ...',      "...\n",      "\n...",      '>...',      '...<',      );
    $znaki_na = array ( ' &ndash; ', '&rsquo;', '&hellip; ', ' &hellip;', "&hellip;\n", "\n&hellip;", '>&hellip;', '&hellip;<', );
    $tekst = str_replace( $znaki_z, $znaki_na, $tekst );
  }
  if ( odczyt_konf('ustawienia','typografia_cudzyslowy') ) {
    preg_match_all ( '/<[^>]*>/i', $tekst, $tablica_cudzyslowy );
     // podziękowania za pomoc dla soanvig-a, http://webax.pl/zamiana-na-t270/#entry2427
    foreach ( $tablica_cudzyslowy as $fragment )
      $tekst = str_replace( $fragment, str_replace('"',"'",$fragment), $tekst );
    $tekst = str_replace( '&quot;', '"', $tekst );
    $cudzyslowy_z  = array ( '>"',       ' "',       '("',       '" ',       '"<',       '")',       '",',       '";',       '".' );
    $cudzyslowy_na = array ( '>&bdquo;', ' &bdquo;', '(&bdquo;', '&rdquo; ', '&rdquo;<', '&rdquo;)', '&rdquo;,', '&rdquo;;', '&rdquo;.' );
    if ( $tekst[0] == '"' )
      $tekst = ' ' . $tekst;
    if ( $tekst[ strlen($tekst)-1 ] == '"' )
      $tekst = $tekst . ' ';
    $tekst = str_replace( $cudzyslowy_z, $cudzyslowy_na, $tekst );
  }
  if ( odczyt_konf('ustawienia','typografia_spojniki') ) {
    $spojniki_z  = array ( '(a ',      '(i ',      '(o ',      '(u ',      '(w ',      '(z ',      ' a ',      ' i ',      ' o ',      ' u ',      ' w ',      ' z ',      ' A ',      ' I ',      ' O ',      ' U ',      ' W ',      ' Z '  );
    $spojniki_na = array ( '(a&nbsp;', '(i&nbsp;', '(o&nbsp;', '(u&nbsp;', '(w&nbsp;', '(z&nbsp;', ' a&nbsp;', ' i&nbsp;', ' o&nbsp;', ' u&nbsp;', ' w&nbsp;', ' z&nbsp;', ' A&nbsp;', ' I&nbsp;', ' O&nbsp;', ' U&nbsp;', ' W&nbsp;', ' Z&nbsp;'  );
    $tekst = str_replace( $spojniki_z, $spojniki_na, $tekst );
  }
  return $tekst;
}

function fragment ( $tekst, $liczba_znakow = 80 ) {
  $tekst = strip_tags($tekst);
  if ( strlen( $tekst ) >  $liczba_znakow )
    $tekst = substr( $tekst, 0, $liczba_znakow ) . '&hellip; ';
  $tekst = tekst( $tekst, false );
  return $tekst;
}

function pokaz_date ( $data_zrodlowa ) {
  if ( function_exists('date_create_from_format') ) {
    $format_daty_docelowej = odczyt_konf ( 'ustawienia', 'format_daty' );
    if ( !$data_robocza = date_create_from_format(FORMAT_DATY,$data_zrodlowa) )
      return $data_zrodlowa;
    $data_docelowa = date_format( $data_robocza, $format_daty_docelowej );
    return $data_docelowa;
  }
  else
    return $data_zrodlowa;
}

function sitemapa () {
  if ( odczyt_konf('ustawienia','przyjazne_adresy') )
    $z = null;
  else
    $z = '?a=';
  $wszystkie_podstrony = wszystkie_podstrony();
  $adres = odczyt_konf ( 'ustawienia', 'adres' );
  $sitemapa = '<?xml version="1.0" encoding="UTF-8"?>' . "\n" . '<urlset xmlns="http://www.sitemaps.org/schemas/sitemap/0.9">' . "\n";
  foreach ( $wszystkie_podstrony as $podstrona )
    $sitemapa .= '   <url>' . "\n" . '      <loc>' . $adres . '/' . $z . $podstrona . '</loc>' . "\n" . '      <changefreq>weekly</changefreq>' . "\n" . '      <priority>1.0</priority>' . "\n" . '   </url>' . "\n";
  $sitemapa .='</urlset>';
  zapisz_plik ( 'sitemap.xml', $sitemapa );
}

function wiadomosc ( $tresc, $temat = 'WizyTowka' ) {
  $email = odczyt_konf('ustawienia','email');
  $tresc .= "\n\n" . '-------------' . "\n" . 'WizyTówka — ' . odczyt_konf('ustawienia','adres');
  if ( @mail( $email, $temat, $tresc, 'Content-type: text/plain; charset=UTF-8' ) )
    return true;
  else
    return false;
}

function przygotuj_haslo ( $ciag ) {
  return sha1( odczyt_konf('uzytkownik','data_instalacji_unix') . $ciag . odczyt_konf('uzytkownik','data_instalacji') );
}

function zalogowany ( $w_panelu_administracyjnym = false ) {
  if ( $w_panelu_administracyjnym and isset($_COOKIE['WizyTowka_administracja']) and $_COOKIE['WizyTowka_administracja'] == odczyt_konf('uzytkownik','kod') and $GLOBALS['kod'] == odczyt_konf('uzytkownik','kod') )
    return true;
  elseif ( !$w_panelu_administracyjnym and isset($_COOKIE['WizyTowka_administracja']) and $_COOKIE['WizyTowka_administracja'] == odczyt_konf('uzytkownik','kod') )
    return true;
  else
    return false;
}

// HTML

function zaznacz_checkbox ( $ustawienie, $wartosc_zaznaczajaca = '1' ) {
  if ( $ustawienie == $wartosc_zaznaczajaca )
    echo 'checked';
}

function generuj_optgroup ( $tablica , $tablica_value = null ) {
  if ( !empty($tablica) ) {
    if ( empty($tablica_value) ) {
      sort($tablica);
      foreach ( $tablica as $element )
        echo '<option>'.$element.'</option>';
    }
    else
      foreach ( $tablica as $numer => $element )
        echo '<option value="'.$tablica_value[$numer].'">'.$element.'</option>';
  }
}

function bezpieczny_html ( $x ) {
  if ( is_array($x) ) {
    foreach ( $x as $nazwa => $element )
      $x[$nazwa] = bezpieczny_html($element);
    return $x;
  }
  else
    return htmlspecialchars($x);
}
